/*****************************************************************************/
/*  MATRIXDEMO.CS   MS-WINDOWS Win32 (95/98/ME/NT/2K/XP)                     */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Example for C#                                                           */
/*****************************************************************************/

using System;
using System.Windows.Forms; // MessageBox
using System.Runtime.InteropServices; // Marshalling

namespace matrix
{
	/// <summary>
	/// Zusammenfassung fE matrixdemo.
	/// </summary>
	public class MatrixDemo
	{
        matrix32mem.API mxapi = new matrix32mem.API();
                
		private short RetCode;
		private int[] DataIn;
		private int[] DataOut;
		private int[] KeyData;
		private int[] DataBlock;
		private short DNG_Count;
		private short DNG_Nummer;
		private short DNG_Mem;
		private short DNG_MaxVar;
		private int DNG_Version;
		private int DNG_SerNr;
		private short VerMajor;
		private short VerMinor;
	
		// ***********************************************************
		// * In diesem Beispiel wird der Demo-UserCode 1234 und      *
		// * LPT-Port 1 verwendet.                                   *
		// * - Setzen Sie DNG_Port = 85, um den USB-Dongle zu testen *
		// ***********************************************************
		const short UserCode = 1234; 

        public MatrixDemo()
		{
			DataIn = new int[256];
			DataOut = new int[256];
			KeyData = new int[4];
			DataBlock = new int[2];

        }

        ~MatrixDemo()
        {
        }

		public void SetActivePort(string Port)
		{
			    
		}

	
		public void Number_of_Dongles()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Anzahl der Dongles an DNG_Port ermitteln                *
			// ***********************************************************
			DNG_Count = mxapi.Count();
		
			if(DNG_Count <= 0)
				MessageBox.Show("hO܂" );
			else
				MessageBox.Show( DNG_Count.ToString() + "̃hO܂");
		
			RetCode = mxapi.Release();
		}


		public void Memory_of_Dongle()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Speichergre des letzten Dongles an DNG_Port lesen und *
			// * die maximale Anzahl der Datenfelder berechnen           *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			DNG_Mem = mxapi.MemSize(DNG_Nummer);
		
			if(DNG_Mem <= 0)
			{
				MessageBox.Show("擾G[!");
				return;
			}
		
			DNG_MaxVar = (short)(DNG_Mem / 4);
		
			MessageBox.Show("hÕtB[h: " + DNG_MaxVar.ToString());	
			
			RetCode = mxapi.Release();
		}
		
		public void Version_of_Dongle()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Die Versionsnummer des letzten Dongles an DNG_Port      *
			// * lesen                                                   *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			DNG_Version = mxapi.Version(DNG_Nummer);
		
			if(DNG_Version <= 0)
			{
				MessageBox.Show("hOo[Wǂݍ݃G[!");
			}
			else
			{
				VerMinor = (short)(DNG_Version & 0xffff);
				VerMajor = (short)(DNG_Version >> 16);
				MessageBox.Show("hOo[W Nr: " + VerMajor.ToString() + "." + VerMinor.ToString());
			}

			RetCode = mxapi.Release();		
		}
	
		public void Read_Dongle_SerNr()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Seriennummer aus dem letzten Dongle an DNG_Port mit     *
			// * dem UserCode lesen und anzeigen.                        *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			DNG_SerNr = mxapi.ReadSerNr(UserCode, DNG_Nummer);
		
			if(DNG_SerNr < 0)
			{
				MessageBox.Show("VA擾G[ " + DNG_SerNr.ToString());
				RetCode = mxapi.Release();
				return;
			}
			MessageBox.Show("VAԍ:  (dec) " + DNG_SerNr.ToString() + "    (hex) " + DNG_SerNr.ToString("X"));
		
			RetCode = mxapi.Release();
		
		}
	
		public void Read_Dongle_Data()
		{
			string MessageString;
			short  i;
		
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * 3 Datenfelder aus dem letzten Dongle an DNG_Port mit    *
			// * dem UserCode lesen und anzeigen.                        *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();

            RetCode = mxapi.ReadData(UserCode, DataIn, (short)3, DNG_Nummer);

			if(RetCode < 0)
			{

				MessageBox.Show("ǂݍ݃G[ " + RetCode.ToString() );
				RetCode = mxapi.Release();
				return;
			}
		
			MessageString = "ǂݍ݃tB[hf[^: \n\n";
			for(i = 0; i <= 2; i++)
			{
				MessageString = MessageString + "Var" + (i + 1).ToString("D4") + ":  " + DataIn[i].ToString() + "\n";
			}
			MessageBox.Show(MessageString);
		
			RetCode = mxapi.Release();
		
		}
	
		public void Write_Dongle_Data()
		{
			short  i;

			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * 3 Datenfelder im letzten Dongle an DNG_Port mit dem     *
			// * UserCode speichern.                                     *
			// * Als Beispiel werden die Werte 101,102,103 gespeichert.  *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			for(i = 0; i <= 2; i++)
			{
				DataOut[i] = 101 + i;
			}

            RetCode = mxapi.WriteData(UserCode, DataOut, 3, DNG_Nummer);
            
			if(RetCode < 0)
				MessageBox.Show("݃G[ " + RetCode.ToString() );
			else
				MessageBox.Show("ݐ");
		
			RetCode = mxapi.Release();		
		}

        public void Dongle_Encrypt_Decrypt()
		{
			string MessageString;
            uint[] Key = new uint[4];

            RetCode = mxapi.Init();

            Key[0] = 0x423A612E;    // dec: 1111122222
            Key[1] = 0x423A8C95;    // dec: 1111133333
            Key[2] = 0x8474C25C;    // dec: 2222244444
            Key[3] = 0x8474EDC3;    // dec: 2222255555

            RetCode = mxapi.WriteKey(UserCode, Key, 1);
            if (RetCode < 0)
            {
                MessageBox.Show("WriteKey G[ " + RetCode.ToString());
                RetCode = mxapi.Release();
                return;
            }

            uint[] DataBlock = new uint[2];

            DataBlock[0] = 0x499602D2;   // dec: 1234567890
            DataBlock[1] = 0x499602D2;   // dec: 1234567890

			MessageString = ":   \t" + "(dec)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(hex)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n";
		
			DNG_Nummer = mxapi.Count();
		
			// ***********************************************************
			// * DatenBlock Eer den Dongle verschlEseln                *
			// ***********************************************************
            RetCode = mxapi.EncryptData(UserCode, DataBlock, DNG_Nummer);
		
			if(RetCode < 0)
			{
				MessageBox.Show("G[ " + RetCode.ToString());
				RetCode = mxapi.Release();
				return;
			}
		
			MessageString = MessageString + "Íf[^: \t(dec)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(hex)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n";
		
			// ***********************************************************
			// * DatenBlock Eer den Dongle entschlEseln                *
			// ***********************************************************
            RetCode = mxapi.DecryptData(UserCode, DataBlock, DNG_Nummer);
		
			if(RetCode < 0)
			{
				MessageBox.Show("G[ " + RetCode.ToString());
				RetCode = mxapi.Release();
			}
		
			MessageBox.Show(MessageString + "f[^: \t(dec)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(hex)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n");
	
			RetCode = mxapi.Release();
		}
	
		public void Version_of_API()
		{
			int RetVer;
		
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Version der Matrix-API lesen und anzeigen               *
			// ***********************************************************
			RetVer = mxapi.VersionAPI();
		
			if(RetVer == 0)
				MessageBox.Show("API-VersionǂݎG[");
			else
			{
				VerMinor = (short)(RetVer & 0xffff);
				VerMajor = (short)(RetVer >> 16);
				MessageBox.Show("Matrix-API Version: " + VerMajor.ToString() + "." + VerMinor.ToString());
			}		
		
			RetCode = mxapi.Release();
		
		}
	

		public void App_Encrypt()
		{
			string MessageString;
			uint[] Key = new uint[4];
			uint[] Data = new uint[2];
		
			Data[0] = 0x499602D2;   // dec: 1234567890
			Data[1] = 0x499602D2;   // dec: 1234567890
		
			Key[0] = 0x423A612E;    // dec: 1111122222
			Key[1] = 0x423A8C95;    // dec: 1111133333
			Key[2] = 0x8474C25C;    // dec: 2222244444
			Key[3] = 0x8474EDC3;    // dec: 2222255555
		
			MessageString = "Clear Data:   \t(dec)  " + Data[0].ToString() + "\t      " + Data[1].ToString() + 
			                          "\n\t\t(hex)  " + Data[0].ToString("X") + "\t      " + Data[1].ToString("X") + 
			                          "\n\n" + 
			                "Key:          \t(dec)  " + Key[0].ToString() + "\t      " + Key[1].ToString() + "\t  " + Key[2].ToString() + "\t" + Key[3].ToString() + 
			                          "\n\t\t(hex)  " + Key[0].ToString("X") + "\t      " + Key[1].ToString() + "\t  " + Key[2].ToString() + "\t" + Key[3].ToString("X") + "\n\n";

			MATRIX_ENCRYPT.MxCrypt.MxApp_Encrypt(Data, Key);
		
			// *** Display Data[0]/Data[1] as long ***
			MessageBox.Show(MessageString + "Encrypted Data: \t(dec)  " + Data[0].ToString() + "\t      " + Data[1].ToString() + 
			                                            "\n\t\t(hex)  " + Data[0].ToString("X") + "\t      " + Data[1].ToString("X") + "\n\n");
		}

	} // end class
} // end namespace

