/*****************************************************************************/
/*  MATRIXDEMO.CS   MS-WINDOWS Win32 (95/98/ME/NT/2K/XP)                     */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Example for C#                                                           */
/*****************************************************************************/

using System;
using System.Windows.Forms; // MessageBox
using System.Runtime.InteropServices; // Marshalling
using MXAPI;

namespace matrix
{
     
    /// <summary>
    /// Zusammenfassung fE matrixdemo.
    /// </summary>
    public class MatrixDemo
	{
		private short RetCode;
		private int[] DataIn;
		private int[] DataOut;
		private int[] KeyData;
		private int[] DataBlock;
		private short DNG_Count;
		private short DNG_Nummer;
		private short DNG_Mem;
		private short DNG_MaxVar;
		private int DNG_Version;
		private int DNG_SerNr;
		private short VerMajor;
		private short VerMinor;
	
		// ***********************************************************
		// * In diesem Beispiel wird der Demo-UserCode 1234 und      *
		// * LPT-Port 1 verwendet.                                   *
		// * - Setzen Sie DNG_Port = 85, um den USB-Dongle zu testen *
		// ***********************************************************
		const short UserCode = 1234;
		short DNG_Port;


        public MatrixDemo()
        {
            DataIn = new int[256];
            DataOut = new int[256];
            KeyData = new int[4];
            DataBlock = new int[2];

        }

        ~MatrixDemo()
        {
            Matrix.Release_UsbMemDetect();
        }

		public void SetActivePort(string Port)
		{
			DNG_Port = 0;
			switch(Port)
			{
				case "USB":
					DNG_Port = 85;
					break;
			}    
		}

	
		public void Number_of_Dongles()
		{
           

			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * Anzahl der Dongles an DNG_Port ermitteln                *
			// ***********************************************************
			DNG_Count = Matrix.Dongle_Count(DNG_Port);
		
			if(DNG_Count <= 0)
				MessageBox.Show("hO܂" );
			else
				MessageBox.Show( DNG_Count.ToString() + "̃hO܂");
		
			RetCode = Matrix.Release_MatrixAPI();
		}


		public void Memory_of_Dongle()
		{
			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * Speichergre des letzten Dongles an DNG_Port lesen und *
			// * die maximale Anzahl der Datenfelder berechnen           *
			// ***********************************************************
			DNG_Nummer = Matrix.Dongle_Count(DNG_Port);
		
			DNG_Mem = Matrix.Dongle_MemSize(DNG_Nummer, DNG_Port);
		
			if(DNG_Mem <= 0)
			{
				MessageBox.Show("擾G[!");
				return;
			}
		
			DNG_MaxVar = (short)(DNG_Mem / 4);
		
			MessageBox.Show("hÕtB[h: " + DNG_MaxVar.ToString());	
			
			RetCode = Matrix.Release_MatrixAPI();
		}
		
		public void Version_of_Dongle()
		{
			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * Die Versionsnummer des letzten Dongles an DNG_Port      *
			// * lesen                                                   *
			// ***********************************************************
			DNG_Nummer = Matrix.Dongle_Count(DNG_Port);
		
			DNG_Version = Matrix.Dongle_Version(DNG_Nummer, DNG_Port);
		
			if(DNG_Version <= 0)
			{
				MessageBox.Show("hOo[Wǂݍ݃G[!");
			}
			else
			{
				VerMinor = (short)(DNG_Version & 0xffff);
				VerMajor = (short)(DNG_Version >> 16);
				MessageBox.Show("hOo[W Nr: " + VerMajor.ToString() + "." + VerMinor.ToString());
			}

			RetCode = Matrix.Release_MatrixAPI();		
		}
	
		public void Read_Dongle_SerNr()
		{
			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * Seriennummer aus dem letzten Dongle an DNG_Port mit     *
			// * dem UserCode lesen und anzeigen.                        *
			// ***********************************************************
			DNG_Nummer = Matrix.Dongle_Count(DNG_Port);
		
			DNG_SerNr = Matrix.Dongle_ReadSerNr(UserCode, DNG_Nummer, DNG_Port);
		
			if(DNG_SerNr < 0)
			{
				MessageBox.Show("VA擾G[ " + DNG_SerNr.ToString());
				RetCode = Matrix.Release_MatrixAPI();
				return;
			}
			MessageBox.Show("VAԍ:  (dec) " + DNG_SerNr.ToString() + "    (hex) " + DNG_SerNr.ToString("X"));
		
			RetCode = Matrix.Release_MatrixAPI();
		
		}
	
		public void Read_Dongle_Data()
		{
			string MessageString;
			short  i;
		
			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * 3 Datenfelder aus dem letzten Dongle an DNG_Port mit    *
			// * dem UserCode lesen und anzeigen.                        *
			// ***********************************************************
			DNG_Nummer = Matrix.Dongle_Count(DNG_Port);

            RetCode = Matrix.Dongle_ReadData(UserCode, ref DataIn[0], (short)3, DNG_Nummer, DNG_Port);

			if(RetCode < 0)
			{

				MessageBox.Show("ǂݍ݃G[ " + RetCode.ToString() );
				RetCode = Matrix.Release_MatrixAPI();
				return;
			}
		
			MessageString = "ǂݍ݃tB[hf[^: \n\n";
			for(i = 0; i <= 2; i++)
			{
				MessageString = MessageString + "Var" + (i + 1).ToString("D4") + ":  " + DataIn[i].ToString() + "\n";
			}
			MessageBox.Show(MessageString);
		
			RetCode = Matrix.Release_MatrixAPI();
		
		}
	
		public void Write_Dongle_Data()
		{
			short  i;

			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * 3 Datenfelder im letzten Dongle an DNG_Port mit dem     *
			// * UserCode speichern.                                     *
			// * Als Beispiel werden die Werte 101,102,103 gespeichert.  *
			// ***********************************************************
			DNG_Nummer = Matrix.Dongle_Count(DNG_Port);
		
			for(i = 0; i <= 2; i++)
			{
				DataOut[i] = 101 + i;
			}

            RetCode = Matrix.Dongle_WriteData(UserCode, ref DataOut[0], 3, DNG_Nummer, DNG_Port);
            
			if(RetCode < 0)
				MessageBox.Show("݃G[ " + RetCode.ToString() );
			else
				MessageBox.Show("ݐ");
		
			RetCode = Matrix.Release_MatrixAPI();		
		}

        public void Dongle_Encrypt_Decrypt()
		{
			string MessageString;
            uint[] Key = new uint[4];

            RetCode = Matrix.Init_MatrixAPI();

            Key[0] = 0x423A612E;    // dec: 1111122222
            Key[1] = 0x423A8C95;    // dec: 1111133333
            Key[2] = 0x8474C25C;    // dec: 2222244444
            Key[3] = 0x8474EDC3;    // dec: 2222255555

            RetCode = Matrix.Dongle_WriteKey(UserCode, ref Key[0], 1, 85);
            if (RetCode < 0)
            {
                MessageBox.Show("WriteKey G[ " + RetCode.ToString());
                RetCode = Matrix.Release_MatrixAPI();
                return;
            }

            uint[] DataBlock = new uint[2];

            DataBlock[0] = 0x499602D2;   // dec: 1234567890
            DataBlock[1] = 0x499602D2;   // dec: 1234567890

		
			MessageString = ":   \t" + "(dec)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(hex)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n";
		
			DNG_Nummer = Matrix.Dongle_Count(DNG_Port);
		
			// ***********************************************************
			// * DatenBlock Eer den Dongle verschlEseln                *
			// ***********************************************************
            RetCode = Matrix.Dongle_EncryptData(UserCode, ref DataBlock[0], DNG_Nummer, DNG_Port);
		
			if(RetCode < 0)
			{
				MessageBox.Show("G[ " + RetCode.ToString());
				RetCode = Matrix.Release_MatrixAPI();
				return;
			}
		
			MessageString = MessageString + "Íf[^: \t(dec)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(hex)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n";
		
			// ***********************************************************
			// * DatenBlock Eer den Dongle entschlEseln                *
			// ***********************************************************
            RetCode = Matrix.Dongle_DecryptData(UserCode, ref DataBlock[0], DNG_Nummer, DNG_Port);
		
			if(RetCode < 0)
			{
				MessageBox.Show("G[ " + RetCode.ToString());
				RetCode = Matrix.Release_MatrixAPI();
			}
		
			MessageBox.Show(MessageString + "f[^: \t(dec)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(hex)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n");
	
			RetCode = Matrix.Release_MatrixAPI();
		}
	
		public void Version_of_API()
		{
			int RetVer;
		
			RetCode = Matrix.Init_MatrixAPI();
		
			// ***********************************************************
			// * Version der Matrix-API lesen und anzeigen               *
			// ***********************************************************
			RetVer = Matrix.GetVersionAPI();
		
			if(RetVer == 0)
				MessageBox.Show("API-VersionǂݎG[");
			else
			{
				VerMinor = (short)(RetVer & 0xffff);
				VerMajor = (short)(RetVer >> 16);
				MessageBox.Show("Matrix-API Version: " + VerMajor.ToString() + "." + VerMinor.ToString());
			}		
		
			RetCode = Matrix.Release_MatrixAPI();
		
		}
	

		public void App_Encrypt()
		{
			string MessageString;
			uint[] Key = new uint[4];
			uint[] Data = new uint[2];
		
			Data[0] = 0x499602D2;   // dec: 1234567890
			Data[1] = 0x499602D2;   // dec: 1234567890
		
			Key[0] = 0x423A612E;    // dec: 1111122222
			Key[1] = 0x423A8C95;    // dec: 1111133333
			Key[2] = 0x8474C25C;    // dec: 2222244444
			Key[3] = 0x8474EDC3;    // dec: 2222255555
		
			MessageString = "Clear Data:   \t(dec)  " + Data[0].ToString() + "\t      " + Data[1].ToString() + 
			                          "\n\t\t(hex)  " + Data[0].ToString("X") + "\t      " + Data[1].ToString("X") + 
			                          "\n\n" + 
			                "Key:          \t(dec)  " + Key[0].ToString() + "\t      " + Key[1].ToString() + "\t  " + Key[2].ToString() + "\t" + Key[3].ToString() + 
			                          "\n\t\t(hex)  " + Key[0].ToString("X") + "\t      " + Key[1].ToString() + "\t  " + Key[2].ToString() + "\t" + Key[3].ToString("X") + "\n\n";

			MATRIX_ENCRYPT.MxCrypt.MxApp_Encrypt(Data, Key);
		
			// *** Display Data[0]/Data[1] as long ***
			MessageBox.Show(MessageString + "Encrypted Data: \t(dec)  " + Data[0].ToString() + "\t      " + Data[1].ToString() + 
			                                            "\n\t\t(hex)  " + Data[0].ToString("X") + "\t      " + Data[1].ToString("X") + "\n\n");
		}

	} // end class
} // end namespace

