/*****************************************************************************/
/*  MXAPI.CS   MS-WINDOWS Win32 (95/98/ME/NT/2K/XP)                          */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Defines to acces the Matrix API in C#                                    */
/*****************************************************************************/

namespace MXAPI
{
    using System;
    using System.Runtime.InteropServices;   /* Required namespace for the DllImport method */

	public class Matrix
	{
         /* This c#-class will import the Matrix API classes */

        [DllImport("matrix32mem.dll", EntryPoint="Init_MatrixAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern short Init_MatrixAPI(bool bCoInitialize=true);

		[DllImport("matrix32mem.dll", EntryPoint="Release_MatrixAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern short Release_MatrixAPI();

		[DllImport("matrix32mem.dll", EntryPoint="GetVersionAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionAPI();

		[DllImport("matrix32mem.dll", EntryPoint="GetVersionDRV", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionDRV();

		[DllImport("matrix32mem.dll", EntryPoint="GetVersionDRV_USB", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionDRV_USB();

		[DllImport("matrix32mem.dll", EntryPoint="PausePrinterActivity", CallingConvention = CallingConvention.StdCall)]
		public static extern short PausePrinterActivity();

		[DllImport("matrix32mem.dll", EntryPoint="ResumePrinterActivity", CallingConvention = CallingConvention.StdCall)]
		public static extern short ResumePrinterActivity();

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_Find", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Find();

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_Version", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_Version(short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_Model", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_Model(short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_MemSize", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_MemSize(short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_Count", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Count(short Port);

        [DllImport("matrix32mem.dll", EntryPoint="Dongle_ReadData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_ReadData(int UserCode, ref int Data, short Count, short DngNr, short Port);

        [DllImport("matrix32mem.dll", EntryPoint="Dongle_ReadDataEx", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_ReadDataEx(int UserCode, ref int Data, short Fpos, short Count, short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_ReadSerNr", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_ReadSerNr(int UserCode, short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_WriteData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteData(int UserCode, ref int Data, short Count, short DngNr, short Port);

        [DllImport("matrix32mem.dll", EntryPoint="Dongle_WriteDataEx", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteDataEx(int UserCode, ref int Data, short Fpos, short Count, short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_WriteKey", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteKey(int UserCode, ref uint KeyData, short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_GetKeyFlag", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_GetKeyFlag(int UserCode, short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_EncryptData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_EncryptData(int UserCode, ref uint DataBlock, short DngNr, short Port);

		[DllImport("matrix32mem.dll", EntryPoint="Dongle_DecryptData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_DecryptData(int UserCode, ref uint DataBlock, short DngNr, short Port);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void UsbMemDetectCallbackDelegate( IntPtr arg);

        [DllImport("matrix32mem.dll", EntryPoint = "Init_UsbMemDetect", CallingConvention = CallingConvention.StdCall)]
        public static extern short Init_UsbMemDetect(UsbMemDetectCallbackDelegate onConnect, UsbMemDetectCallbackDelegate onDisconnect, IntPtr arg);

        [DllImport("matrix32mem.dll", EntryPoint = "Release_UsbMemDetect", CallingConvention = CallingConvention.StdCall)]
        public static extern short Release_UsbMemDetect();

    }
}

